#include <stdio.h>
#include <cstring>
#include <time.h>
#include <string>
using namespace std;


int main(int argc, char *argv[])
{
	FILE *in, *out;

	if (argc<2) {
		printf("Usage: wrap filename\n");
 		return EXIT_FAILURE;
 	}

	string filename = string(argv[1]);
	string input = filename + ".txt";
	errno_t nerr;
	if (argc>2) {
		string input = string(argv[2]);
		nerr = fopen_s(&in,input.c_str(),"r");
		if (nerr) {
			printf("Could not open input: %s\n",input.c_str());
			return EXIT_FAILURE;
		}
	}
	else in = stdin;
	string output = filename + ".html";
	nerr = fopen_s(&out,output.c_str(),"w");
	if (nerr) {
		printf("could not open output: %s\n",output.c_str());
		return EXIT_FAILURE;
	}
	fprintf(out,"<html>\n");
	fprintf(out,"<head>\n<title>%s</title>\n</head>\n",filename.c_str());
	fprintf(out,"<body>\n<h2><a name=\"%s\">",filename.c_str());
	fprintf(out,"<code>%s</code></h2>\n",filename.c_str());
	fprintf(out,"\n<p><hr>\n");

	// copy html source file
	int nchar;
	while ((nchar = fgetc(in)) != EOF) fputc(nchar,out);

	// results
	fprintf(out,"<p><hr>\n\n<h3>Results</h3>\n");
	fprintf(out,"\n\n\n<pre>\n</pre>\n\n");

	// update
	fprintf(out,"<p><hr>\n\n<p>Maintained by <a href=""http://www.johnloomis.org"">John Loomis</a>,\n");
   
	char buf[32];
	time_t ltime;
	time( &ltime );
	nerr = ctime_s(buf,30,&ltime);
	nchar = strlen(buf);
	buf[nchar-1] = 0;
	fprintf(out,"updated <i>%s</i>\n",buf);
	fprintf(out,"\n</body></html>\n");
	fclose(in);
	fclose(out);
	return EXIT_SUCCESS;
}
	 